---
product: "AG Grid"
title: "Text Filter"
description: "Text Filters allow you to filter string data."
framework: javascript
version: "36.2.0"
related:
    - title: "Number Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-number/"
    - title: "BigInt Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-bigint/"
    - title: "Date Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-date/"
    - title: "Set Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set/"
    - title: "Multi Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-multi/"
    - title: "Filter Conditions"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-conditions/"
    - title: "Applying Filters"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-applying/"
    - title: "Filter API"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Text Filter

Text Filters allow you to filter string data.

![Text Filter](https://www.ag-grid.com/archive/36.2.0/_astro/text-filter.m8-Z5BzG.png)

## Enabling Text Filters

#### Text Filter

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);

const columnDefs: ColDef[] = [
  {
    field: "athlete",
    filter: true,
  },
  {
    field: "country",
    filter: "agTextColumnFilter",
  },
  {
    field: "sport",
    filter: true,
  },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    flex: 1,
  },
  columnDefs,
  rowData: null,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Text Filter](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-filter/typescript/)

The Text Filter is the default filter used in AG Grid Community, but it can also be explicitly configured as shown below:

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'athlete',
            // Text Filter is used by default in Community version
            filter: true,
            filterParams: {
                // pass in additional parameters to the Text Filter
            },
        },
        {
            field: 'country',
            // explicitly configure column to use the Text Filter
            filter: 'agTextColumnFilter',
            filterParams: {
                // pass in additional parameters to the Text Filter
            },
        },
    ],

    // other grid options ...
}
```

## Text Filter Parameters

Text Filters are configured though the `filterParams` attribute of the column definition (`ITextFilterParams` interface):

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `browserAutoComplete` | `boolean \| string` |  |  |  |
| `buttons` | `FilterAction[]` |  |  |  |
| `caseSensitive` | `boolean` |  |  |  |
| `closeOnApply` | `boolean` |  |  |  |
| `debounceMs` | `number` |  |  |  |
| `defaultJoinOperator` | `JoinOperator` |  |  |  |
| `defaultOption` | `TextFilterOptionKey \| CustomFilterOptionKey` |  |  |  |
| `filterOptions` | `(IFilterOptionDef \| TextFilterOptionKey \| AdvancedFilterOnlyOptionKey)[]` |  |  |  |
| `filterPlaceholder` | `FilterPlaceholderFunction \| string` |  |  |  |
| `maxNumConditions` | `number` |  |  |  |
| `numAlwaysVisibleConditions` | `number` |  |  |  |
| `readOnly` | `boolean` |  |  |  |
| `textFormatter` | `Function` |  |  |  |
| `textMatcher` | `TextMatcher` |  |  |  |
| `trimInput` | `boolean` |  |  |  |

The following example demonstrates configuring different Text Filter parameters:

- For the **Athlete** column:
  - The filter has a debounce of 200ms (`debounceMs = 200`).
  - Only one Filter Condition is allowed (`maxNumConditions = 1`)
- For the **Country** column:
  - The filter input will be trimmed when the filter is applied (`trimInput = true`)
  - There is a debounce of 1000ms (`debounceMs = 1000`)
- For the **Sport** column:
  - The filter is case-sensitive (`caseSensitive = true`)

#### Text Filter Parameters

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);

const columnDefs: ColDef[] = [
  {
    field: "athlete",
    filterParams: {
      debounceMs: 200,
      maxNumConditions: 1,
    } as ITextFilterParams,
  },
  {
    field: "country",
    filterParams: {
      trimInput: true,
      debounceMs: 1000,
    } as ITextFilterParams,
  },
  {
    field: "sport",
    filterParams: {
      caseSensitive: true,
    } as ITextFilterParams,
  },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    flex: 1,
    filter: true,
  },
  columnDefs,
  rowData: null,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Text Filter Parameters](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-filter-parameters/typescript/)

Filter input fields share the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/input-fields/).

## Text Formatter

By default, the grid compares the Text Filter with the values in a case-insensitive way, by converting both the filter text and the values to lower case and comparing them; for example, `'o'` will match `'Olivia'` and `'Salmon'`. If you instead want to have case-sensitive matches, you can set `caseSensitive = true` in the `filterParams`, so that no lowercasing is performed. In this case, `'o'` would no longer match `'Olivia'`.

You might have more advanced requirements, for example to ignore accented characters. In this case, you can provide your own `textFormatter`, which is a function with the following signature:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `textFormatter` | `Function` |  |  |  |

`from` is the value coming from the grid. This can be from the `valueGetter` if there is any for the column, or the value as originally provided in the `rowData`. The function should return a string to be used for the purpose of filtering.

The Text Formatter is applied to both the filter text and the values before they are compared.

The following is an example function to remove accents and convert to lower case.

```js
const toLowerWithoutAccents = value => value == null
    ? null
    : value.toLowerCase()
        .replace(/[àáâãäå]/g, 'a')
        .replace(/æ/g, 'ae')
        .replace(/ç/g, 'c')
        .replace(/[èéêë]/g, 'e')
        .replace(/[ìíîï]/g, 'i')
        .replace(/ñ/g, 'n')
        .replace(/[òóôõö]/g, 'o')
        .replace(/œ/g, 'oe')
        .replace(/[ùúûü]/g, 'u')
        .replace(/[ýÿ]/g, 'y');
```

Note that when providing a Text Formatter, the `caseSensitive` parameter is ignored. In this situation, if you want to do a case-insensitive comparison, you will need to perform case conversion inside the `textFormatter` function.

The example below demonstrates a `textFormatter` on the **Athlete** column:

- If you search for `'o'` it will find `'ö'`. You can try this by searching the string `'Bjo'`.

#### Text Formatter

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);

const athleteFilterParams: ITextFilterParams = {
  textFormatter: (r) => {
    if (r == null) return null;

    return r
      .toLowerCase()
      .replace(/[àáâãäå]/g, "a")
      .replace(/æ/g, "ae")
      .replace(/ç/g, "c")
      .replace(/[èéêë]/g, "e")
      .replace(/[ìíîï]/g, "i")
      .replace(/ñ/g, "n")
      .replace(/[òóôõö]/g, "o")
      .replace(/œ/g, "oe")
      .replace(/[ùúûü]/g, "u")
      .replace(/[ýÿ]/g, "y");
  },
};

const columnDefs: ColDef[] = [
  {
    field: "athlete",
    filterParams: athleteFilterParams,
  },
  {
    field: "country",
  },
  {
    field: "sport",
  },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    flex: 1,
    filter: true,
  },
  columnDefs,
  rowData: null,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Text Formatter](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-formatter/typescript/)

## Text Custom Matcher

In most cases, you can customise the Text Filter matching logic by providing your own [Text Formatter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-text/#text-formatter), e.g. to remove or replace characters in the filter text and values. The Text Formatter is applied to both the filter text and values before the filter comparison is performed.

For more advanced use cases, you can provide your own `textMatcher` to decide when to include a row in the filtered results. For example, you might want to apply different logic for the filter option `equals` than for `contains`.

The [Advanced Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-advanced/) compares text with the same `textFormatter`, `textMatcher` and `trimInput` the column is configured with, so a condition written there matches the rows this filter matches. `params.source` tells a `textFormatter` or `textMatcher` which of the two is asking.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `textMatcher` | `TextMatcher` |  |  |  |

The following is an example of a `textMatcher` that mimics the current implementation of AG Grid. This can be used as a template to create your own.

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'athlete',
            filter: 'agTextColumnFilter',
            filterParams: {
                textMatcher: ({ filterOption, value, filterText }) => {
                    if (filterText == null) {
                        return false;
                    }
                    switch (filterOption) {
                        case 'contains':
                            return value.indexOf(filterText) >= 0;
                        case 'notContains':
                            return value.indexOf(filterText) < 0;
                        case 'equals':
                            return value === filterText;
                        case 'notEqual':
                            return value != filterText;
                        case 'startsWith':
                            return value.indexOf(filterText) === 0;
                        case 'endsWith':
                            const index = value.lastIndexOf(filterText);
                            return index >= 0 && index === (value.length - filterText.length);
                        default:
                            // should never happen
                            console.warn('invalid filter type ' + filterOption);
                            return false;
                    }
                }
            }
        }
    ],

    // other grid options ...
}
```

Note that the `textMatcher` is not called for the `blank` and `notBlank` options.

The example below demonstrates a `textMatcher` on the **Country** column:

- Most options are implemented as per the default grid implementation above.
- The `contains` option has additional logic so that aliases can be entered in the filter. E.g. if you filter using the text `'usa'` it will match `United States`, or `'holland'` will match `'Netherlands'`.

#### Text Custom Matcher

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);

function contains(target: string, lookingFor: string) {
  return target && target.indexOf(lookingFor) >= 0;
}

const countryFilterParams: ITextFilterParams = {
  textMatcher: ({ filterOption, value, filterText }) => {
    if (filterText == null) {
      return false;
    }
    switch (filterOption) {
      case "contains":
        const aliases: Record<string, string> = {
          usa: "united states",
          holland: "netherlands",
        };

        const literalMatch = contains(value, filterText || "");

        return !!literalMatch || !!contains(value, aliases[filterText || ""]);
      case "notContains":
        return value.indexOf(filterText) < 0;
      case "equals":
        return value === filterText;
      case "notEqual":
        return value != filterText;
      case "startsWith":
        return value.indexOf(filterText) === 0;
      case "endsWith":
        const index = value.lastIndexOf(filterText);
        return index >= 0 && index === value.length - filterText.length;
      default:
        // should never happen
        console.warn("invalid filter type " + filterOption);
        return false;
    }
  },
};

const columnDefs: ColDef[] = [
  {
    field: "country",
    filterParams: countryFilterParams,
  },
  {
    field: "athlete",
  },
  {
    field: "sport",
  },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    flex: 1,
    filter: true,
  },
  columnDefs: columnDefs,
  rowData: null,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Text Custom Matcher](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-custom-matcher/typescript/)

## Text Filter Model

The Filter Model describes the current state of the applied Text Filter. If only one [Filter Condition](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-conditions/) is set, this will be a `TextFilterModel`:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `type` | `TextFilterOptionKey \| CustomFilterOptionKey \| null` |  |  |  |
| `filterType` | `'text'` |  |  |  |
| `filter` | `string \| null` |  |  |  |
| `filterTo` | `string \| null` |  |  |  |

If more than one Filter Condition is set, then multiple instances of the model are created and wrapped inside a Combined Model (`ICombinedSimpleModel<TextFilterModel>`). A Combined Model looks as follows:

```ts
// A filter combining multiple conditions
interface ICombinedSimpleModel<TextFilterModel> {
    filterType: string;

    operator: JoinOperator;

    // multiple instances of the Filter Model
    conditions: TextFilterModel[];
}

type JoinOperator = 'AND' | 'OR';
```

An example of a Filter Model with two conditions is as follows:

```js
// Text Filter with two conditions, both are equals type
const textEqualsSwimmingOrEqualsGymnastics = {
    filterType: 'text',
    operator: 'OR',
    conditions: [
        {
            filterType: 'text',
            type: 'equals',
            filter: 'Swimming'
        },
        {
            filterType: 'text',
            type: 'equals',
            filter: 'Gymnastics'
        }
    ]
};
```

## Text Filter Options

The Text Filter presents a list of [Filter Options](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-conditions/#filter-options) to the user.

The list of options is as follows:

| Option Name | Option Key | Included by Default |
| --- | --- | --- |
| Contains | `contains` | Yes |
| Does not contain | `notContains` | Yes |
| Equals | `equals` | Yes |
| Does not equal | `notEqual` | Yes |
| Begins with | `startsWith` | Yes |
| Ends with | `endsWith` | Yes |
| Blank | `blank` | Yes |
| Not blank | `notBlank` | Yes |
| Choose one | `empty` | No |

Note that the `empty` filter option is primarily used when creating [Custom Filter Options](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-conditions/#custom-filter-options). When 'Choose one' is displayed, the filter is not active.

The default option for the Text Filter is `contains`.

When providing filter options, the default filter option (or the first option if no default set) must be an option that displays an input or the `empty` filter option (as a filter option with no inputs would mean the filter is active by default).

The example below demonstrates configuring different filter options:

- For the **Athlete** column, there are only two filter options: `filterOptions = ['contains', 'notContains']`.
- For the **Country** column, there is only one filter option: `filterOptions = ['contains']`.
- For the **Sport** column, there is a different default filter option: `defaultOption = 'startsWith'`.

#### Text Filter Options

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);

const columnDefs: ColDef[] = [
  {
    field: "athlete",
    filterParams: {
      filterOptions: ["contains", "notContains"],
      maxNumConditions: 1,
    } as ITextFilterParams,
  },
  {
    field: "country",
    filterParams: {
      filterOptions: ["contains"],
    } as ITextFilterParams,
  },
  {
    field: "sport",
    filterParams: {
      defaultOption: "startsWith",
    } as ITextFilterParams,
  },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    flex: 1,
    filter: true,
  },
  columnDefs,
  rowData: null,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Text Filter Options](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-filter-options/typescript/)

## Text Filter Values

By default, the values supplied to the Text Filter are retrieved from the data based on the `field` attribute. This can be overridden by providing a `filterValueGetter` in the Column Definition. This is similar to using a [Value Getter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-getters/), but is specific to the filter.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filterValueGetter` | `string \| ValueGetterFunc` |  |  |  |

## Applying the Text Filter

Applying the Text Filter is described in more detail in the following sections:

- [Apply, Clear, Reset and Cancel Buttons](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-applying/#apply-clear-reset-and-cancel-buttons)
- [Applying the UI Model](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-applying/#applying-the-ui-model)

## Data Updates

The Text Filter is not affected by data changes. When the grid data is updated, the filter value will remain unchanged and the filter will be re-applied based on the updated data (e.g. the displayed rows will update if necessary).


Text Filters allow you to filter string data.
Enabling Text Filters Copy Link
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "athlete",
filter: true,
},
{
field: "country",
filter: "agTextColumnFilter",
},
{
field: "sport",
filter: true,
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The Text Filter is the default filter used in AG Grid Community, but it can also be explicitly configured as shown below:
<ag-grid-vue
:columnDefs="columnDefs"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
{
field: 'athlete',
// Text Filter is used by default in Community version
filter: true,
filterParams: {
// pass in additional parameters to the Text Filter
},
},
{
field: 'country',
// explicitly configure column to use the Text Filter
filter: 'agTextColumnFilter',
filterParams: {
// pass in additional parameters to the Text Filter
},
},
]; Text Filter Parameters Copy Link
Text Filters are configured though the filterParams attribute of the column definition (ITextFilterParams interface):
Specifies the buttons to be shown in the filter, in the order they should be displayed in. The options are: 'apply': If the Apply button is present, the filter is only applied after the user hits the Apply button. 'clear': The Clear button will clear the (form) details of the filter without removing any active filters on the column. 'reset': The Reset button will clear the details of the filter and any active filters on that column. 'cancel': The Cancel button will discard any changes that have been made to the filter in the UI, restoring the applied model. |
By default, text filtering is case-insensitive. Set this to true to make text filtering case-sensitive. |
If the Apply button is present, the filter popup will be closed immediately when the Apply or Reset button is clicked if this is set to true. |
Overrides the default debounce time in milliseconds for the filter. Defaults are: TextFilter and NumberFilter: 500ms. (These filters have text field inputs, so a short delay before the input is formatted and the filtering applied is usually appropriate). DateFilter and SetFilter: 0ms |
By default, the two conditions are combined using AND. You can change this default by setting this property. Options: AND, OR
|
The default filter option to be selected. |
Array of filter options to present to the user.
|
Placeholder text for the filter textbox.
|
Maximum number of conditions allowed in the filter. |
By default only one condition is shown, and additional conditions are made visible when the previous conditions are entered (up to maxNumConditions). To have more conditions shown by default, set this to the number required. Conditions will be disabled until the previous conditions have been entered. Note that this cannot be greater than maxNumConditions - anything larger will be ignored. |
If set to true, disables controls in the filter to mutate its state. Normally this would be used in conjunction with the Filter API. |
Formats the text before applying the filter compare logic. Useful if you want to substitute accented characters, for example.
|
Used to override how to filter based on the user input. Returns true if the value passes the filter, otherwise false.
|
If true, the input that the user enters will be trimmed when the filter is applied, so any leading or trailing whitespace will be removed. If only whitespace is entered, it will be left as-is. If you enable trimInput, it is best to also increase the debounceMs to give users more time to enter text. |
The following example demonstrates configuring different Text Filter parameters:
- For the Athlete column:
- The filter has a debounce of 200ms (
debounceMs = 200). - Only one Filter Condition is allowed (
maxNumConditions = 1)
- The filter has a debounce of 200ms (
- For the Country column:
- The filter input will be trimmed when the filter is applied (
trimInput = true) - There is a debounce of 1000ms (
debounceMs = 1000)
- The filter input will be trimmed when the filter is applied (
- For the Sport column:
- The filter is case-sensitive (
caseSensitive = true)
- The filter is case-sensitive (
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ITextFilterParams,
ModuleRegistry,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "athlete",
filterParams: {
debounceMs: 200,
maxNumConditions: 1,
} as ITextFilterParams,
},
{
field: "country",
filterParams: {
trimInput: true,
debounceMs: 1000,
} as ITextFilterParams,
},
{
field: "sport",
filterParams: {
caseSensitive: true,
} as ITextFilterParams,
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
filter: true,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Text Formatter Copy Link
By default, the grid compares the Text Filter with the values in a case-insensitive way, by converting both the filter text and the values to lower case and comparing them; for example, 'o' will match 'Olivia' and 'Salmon'. If you instead want to have case-sensitive matches, you can set caseSensitive = true in the filterParams, so that no lowercasing is performed. In this case, 'o' would no longer match 'Olivia'.
You might have more advanced requirements, for example to ignore accented characters. In this case, you can provide your own textFormatter, which is a function with the following signature:
Formats the text before applying the filter compare logic. Useful if you want to substitute accented characters, for example.
|
from is the value coming from the grid. This can be from the valueGetter if there is any for the column, or the value as originally provided in the rowData. The function should return a string to be used for the purpose of filtering.
The Text Formatter is applied to both the filter text and the values before they are compared.
The following is an example function to remove accents and convert to lower case.
const toLowerWithoutAccents = value => value == null
? null
: value.toLowerCase()
.replace(/[à åùãÀÄ]/g, 'a')
.replace(/ĂŠ/g, 'ae')
.replace(/ç/g, 'c')
.replace(/[ÚéĂȘĂ«]/g, 'e')
.replace(/[ĂŹĂßï]/g, 'i')
.replace(/ñ/g, 'n')
.replace(/[ĂČóÎÔö]/g, 'o')
.replace(/Ć/g, 'oe')
.replace(/[ĂčĂșĂ»ĂŒ]/g, 'u')
.replace(/[ĂœĂż]/g, 'y');Note that when providing a Text Formatter, the caseSensitive parameter is ignored. In this situation, if you want to do a case-insensitive comparison, you will need to perform case conversion inside the textFormatter function.
The example below demonstrates a textFormatter on the Athlete column:
- If you search for
'o'it will find'ö'. You can try this by searching the string'Bjo'.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ITextFilterParams,
ModuleRegistry,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);
const athleteFilterParams: ITextFilterParams = {
textFormatter: (r) => {
if (r == null) return null;
return r
.toLowerCase()
.replace(/[à åùãÀÄ]/g, "a")
.replace(/ĂŠ/g, "ae")
.replace(/ç/g, "c")
.replace(/[ÚéĂȘĂ«]/g, "e")
.replace(/[ĂŹĂßï]/g, "i")
.replace(/ñ/g, "n")
.replace(/[ĂČóÎÔö]/g, "o")
.replace(/Ć/g, "oe")
.replace(/[ĂčĂșĂ»ĂŒ]/g, "u")
.replace(/[ĂœĂż]/g, "y");
},
};
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "athlete",
filterParams: athleteFilterParams,
},
{
field: "country",
},
{
field: "sport",
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
filter: true,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Text Custom Matcher Copy Link
In most cases, you can customise the Text Filter matching logic by providing your own Text Formatter, e.g. to remove or replace characters in the filter text and values. The Text Formatter is applied to both the filter text and values before the filter comparison is performed.
For more advanced use cases, you can provide your own textMatcher to decide when to include a row in the filtered results. For example, you might want to apply different logic for the filter option equals than for contains.
Used to override how to filter based on the user input. Returns true if the value passes the filter, otherwise false.
|
The following is an example of a textMatcher that mimics the current implementation of AG Grid. This can be used as a template to create your own.
<ag-grid-vue
:columnDefs="columnDefs"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
{
field: 'athlete',
filter: 'agTextColumnFilter',
filterParams: {
textMatcher: ({ filterOption, value, filterText }) => {
if (filterText == null) {
return false;
}
switch (filterOption) {
case 'contains':
return value.indexOf(filterText) >= 0;
case 'notContains':
return value.indexOf(filterText) < 0;
case 'equals':
return value === filterText;
case 'notEqual':
return value != filterText;
case 'startsWith':
return value.indexOf(filterText) === 0;
case 'endsWith':
const index = value.lastIndexOf(filterText);
return index >= 0 && index === (value.length - filterText.length);
default:
// should never happen
console.warn('invalid filter type ' + filterOption);
return false;
}
}
}
}
];Note that the textMatcher is not called for the blank and notBlank options.
The example below demonstrates a textMatcher on the Country column:
- Most options are implemented as per the default grid implementation above.
- The
containsoption has additional logic so that aliases can be entered in the filter. E.g. if you filter using the text'usa'it will matchUnited States, or'holland'will match'Netherlands'.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ITextFilterParams,
ModuleRegistry,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);
function contains(target: string, lookingFor: string) {
return target && target.indexOf(lookingFor) >= 0;
}
const countryFilterParams: ITextFilterParams = {
textMatcher: ({ filterOption, value, filterText }) => {
if (filterText == null) {
return false;
}
switch (filterOption) {
case "contains":
const aliases: Record<string, string> = {
usa: "united states",
holland: "netherlands",
};
const literalMatch = contains(value, filterText || "");
return !!literalMatch || !!contains(value, aliases[filterText || ""]);
case "notContains":
return value.indexOf(filterText) < 0;
case "equals":
return value === filterText;
case "notEqual":
return value != filterText;
case "startsWith":
return value.indexOf(filterText) === 0;
case "endsWith":
const index = value.lastIndexOf(filterText);
return index >= 0 && index === value.length - filterText.length;
default:
// should never happen
console.warn("invalid filter type " + filterOption);
return false;
}
},
};
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "country",
filterParams: countryFilterParams,
},
{
field: "athlete",
},
{
field: "sport",
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
filter: true,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Text Filter Model Copy Link
The Filter Model describes the current state of the applied Text Filter. If only one Filter Condition is set, this will be a TextFilterModel:
Filter type is always 'text' |
The text value associated with the filter. It's optional as custom filters may not have a text value.
|
The 2nd text value associated with the filter, if supported.
|
One of the filter options, e.g. 'equals' |
If more than one Filter Condition is set, then multiple instances of the model are created and wrapped inside a Combined Model (ICombinedSimpleModel<TextFilterModel>). A Combined Model looks as follows:
// A filter combining multiple conditions
interface ICombinedSimpleModel<TextFilterModel> {
filterType: string;
operator: JoinOperator;
// multiple instances of the Filter Model
conditions: TextFilterModel[];
}
type JoinOperator = 'AND' | 'OR';An example of a Filter Model with two conditions is as follows:
// Text Filter with two conditions, both are equals type
const textEqualsSwimmingOrEqualsGymnastics = {
filterType: 'text',
operator: 'OR',
conditions: [
{
filterType: 'text',
type: 'equals',
filter: 'Swimming'
},
{
filterType: 'text',
type: 'equals',
filter: 'Gymnastics'
}
]
}; Text Filter Options Copy Link
The Text Filter presents a list of Filter Options to the user.
The list of options is as follows:
| Option Name | Option Key | Included by Default |
|---|---|---|
| Contains | contains | Yes |
| Does not contain | notContains | Yes |
| Equals | equals | Yes |
| Does not equal | notEqual | Yes |
| Begins with | startsWith | Yes |
| Ends with | endsWith | Yes |
| Blank | blank | Yes |
| Not blank | notBlank | Yes |
| Choose one | empty | No |
Note that the empty filter option is primarily used when creating Custom Filter Options. When 'Choose one' is displayed, the filter is not active.
The default option for the Text Filter is contains.
When providing filter options, the default filter option (or the first option if no default set) must be an option that displays an input or the empty filter option (as a filter option with no inputs would mean the filter is active by default).
The example below demonstrates configuring different filter options:
- For the Athlete column, there are only two filter options:
filterOptions = ['contains', 'notContains']. - For the Country column, there is only one filter option:
filterOptions = ['contains']. - For the Sport column, there is a different default filter option:
defaultOption = 'startsWith'.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ITextFilterParams,
ModuleRegistry,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "athlete",
filterParams: {
filterOptions: ["contains", "notContains"],
maxNumConditions: 1,
} as ITextFilterParams,
},
{
field: "country",
filterParams: {
filterOptions: ["contains"],
} as ITextFilterParams,
},
{
field: "sport",
filterParams: {
defaultOption: "startsWith",
} as ITextFilterParams,
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
filter: true,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Text Filter Values Copy Link
By default, the values supplied to the Text Filter are retrieved from the data based on the field attribute. This can be overridden by providing a filterValueGetter in the Column Definition. This is similar to using a Value Getter, but is specific to the filter.
Function or expression. Gets the value for filtering purposes. |
Applying the Text Filter Copy Link
Applying the Text Filter is described in more detail in the following sections:
Data Updates Copy Link
The Text Filter is not affected by data changes. When the grid data is updated, the filter value will remain unchanged and the filter will be re-applied based on the updated data (e.g. the displayed rows will update if necessary).

---
product: "AG Grid"
title: "Text Filter"
description: "Text Filters allow you to filter string data."
framework: react
version: "36.2.0"
related:
    - title: "Number Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-number/"
    - title: "BigInt Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-bigint/"
    - title: "Date Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-date/"
    - title: "Set Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set/"
    - title: "Multi Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-multi/"
    - title: "Filter Conditions"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-conditions/"
    - title: "Applying Filters"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-applying/"
    - title: "Filter API"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Text Filter

Text Filters allow you to filter string data.

![Text Filter](https://www.ag-grid.com/archive/36.2.0/_astro/text-filter.m8-Z5BzG.png)

## Enabling Text Filters

#### Text Filter

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule, TextFilterModule];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      filter: true,
    },
    {
      field: "country",
      filter: "agTextColumnFilter",
    },
    {
      field: "sport",
      filter: true,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Text Filter](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-filter/reactFunctionalTs/)

The Text Filter is the default filter used in AG Grid Community, but it can also be explicitly configured as shown below:

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'athlete',
        // Text Filter is used by default in Community version
        filter: true,
        filterParams: {
            // pass in additional parameters to the Text Filter
        },
    },
    {
        field: 'country',
        // explicitly configure column to use the Text Filter
        filter: 'agTextColumnFilter',
        filterParams: {
            // pass in additional parameters to the Text Filter
        },
    },
]);

<AgGridReact columnDefs={columnDefs} />
```

## Text Filter Parameters

Text Filters are configured though the `filterParams` attribute of the column definition (`ITextFilterParams` interface):

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `browserAutoComplete` | `boolean \| string` |  |  |  |
| `buttons` | `FilterAction[]` |  |  |  |
| `caseSensitive` | `boolean` |  |  |  |
| `closeOnApply` | `boolean` |  |  |  |
| `debounceMs` | `number` |  |  |  |
| `defaultJoinOperator` | `JoinOperator` |  |  |  |
| `defaultOption` | `TextFilterOptionKey \| CustomFilterOptionKey` |  |  |  |
| `filterOptions` | `(IFilterOptionDef \| TextFilterOptionKey \| AdvancedFilterOnlyOptionKey)[]` |  |  |  |
| `filterPlaceholder` | `FilterPlaceholderFunction \| string` |  |  |  |
| `maxNumConditions` | `number` |  |  |  |
| `numAlwaysVisibleConditions` | `number` |  |  |  |
| `readOnly` | `boolean` |  |  |  |
| `textFormatter` | `Function` |  |  |  |
| `textMatcher` | `TextMatcher` |  |  |  |
| `trimInput` | `boolean` |  |  |  |

The following example demonstrates configuring different Text Filter parameters:

- For the **Athlete** column:
  - The filter has a debounce of 200ms (`debounceMs = 200`).
  - Only one Filter Condition is allowed (`maxNumConditions = 1`)
- For the **Country** column:
  - The filter input will be trimmed when the filter is applied (`trimInput = true`)
  - There is a debounce of 1000ms (`debounceMs = 1000`)
- For the **Sport** column:
  - The filter is case-sensitive (`caseSensitive = true`)

#### Text Filter Parameters

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule, TextFilterModule];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      filterParams: {
        debounceMs: 200,
        maxNumConditions: 1,
      } as ITextFilterParams,
    },
    {
      field: "country",
      filterParams: {
        trimInput: true,
        debounceMs: 1000,
      } as ITextFilterParams,
    },
    {
      field: "sport",
      filterParams: {
        caseSensitive: true,
      } as ITextFilterParams,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      filter: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Text Filter Parameters](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-filter-parameters/reactFunctionalTs/)

Filter input fields share the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/react-data-grid/input-fields/).

## Text Formatter

By default, the grid compares the Text Filter with the values in a case-insensitive way, by converting both the filter text and the values to lower case and comparing them; for example, `'o'` will match `'Olivia'` and `'Salmon'`. If you instead want to have case-sensitive matches, you can set `caseSensitive = true` in the `filterParams`, so that no lowercasing is performed. In this case, `'o'` would no longer match `'Olivia'`.

You might have more advanced requirements, for example to ignore accented characters. In this case, you can provide your own `textFormatter`, which is a function with the following signature:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `textFormatter` | `Function` |  |  |  |

`from` is the value coming from the grid. This can be from the `valueGetter` if there is any for the column, or the value as originally provided in the `rowData`. The function should return a string to be used for the purpose of filtering.

The Text Formatter is applied to both the filter text and the values before they are compared.

The following is an example function to remove accents and convert to lower case.

```js
const toLowerWithoutAccents = value => value == null
    ? null
    : value.toLowerCase()
        .replace(/[àáâãäå]/g, 'a')
        .replace(/æ/g, 'ae')
        .replace(/ç/g, 'c')
        .replace(/[èéêë]/g, 'e')
        .replace(/[ìíîï]/g, 'i')
        .replace(/ñ/g, 'n')
        .replace(/[òóôõö]/g, 'o')
        .replace(/œ/g, 'oe')
        .replace(/[ùúûü]/g, 'u')
        .replace(/[ýÿ]/g, 'y');
```

Note that when providing a Text Formatter, the `caseSensitive` parameter is ignored. In this situation, if you want to do a case-insensitive comparison, you will need to perform case conversion inside the `textFormatter` function.

The example below demonstrates a `textFormatter` on the **Athlete** column:

- If you search for `'o'` it will find `'ö'`. You can try this by searching the string `'Bjo'`.

#### Text Formatter

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule, TextFilterModule];

const athleteFilterParams: ITextFilterParams = {
  textFormatter: (r) => {
    if (r == null) return null;
    return r
      .toLowerCase()
      .replace(/[àáâãäå]/g, "a")
      .replace(/æ/g, "ae")
      .replace(/ç/g, "c")
      .replace(/[èéêë]/g, "e")
      .replace(/[ìíîï]/g, "i")
      .replace(/ñ/g, "n")
      .replace(/[òóôõö]/g, "o")
      .replace(/œ/g, "oe")
      .replace(/[ùúûü]/g, "u")
      .replace(/[ýÿ]/g, "y");
  },
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      filterParams: athleteFilterParams,
    },
    {
      field: "country",
    },
    {
      field: "sport",
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      filter: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Text Formatter](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-formatter/reactFunctionalTs/)

## Text Custom Matcher

In most cases, you can customise the Text Filter matching logic by providing your own [Text Formatter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-text/#text-formatter), e.g. to remove or replace characters in the filter text and values. The Text Formatter is applied to both the filter text and values before the filter comparison is performed.

For more advanced use cases, you can provide your own `textMatcher` to decide when to include a row in the filtered results. For example, you might want to apply different logic for the filter option `equals` than for `contains`.

The [Advanced Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-advanced/) compares text with the same `textFormatter`, `textMatcher` and `trimInput` the column is configured with, so a condition written there matches the rows this filter matches. `params.source` tells a `textFormatter` or `textMatcher` which of the two is asking.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `textMatcher` | `TextMatcher` |  |  |  |

The following is an example of a `textMatcher` that mimics the current implementation of AG Grid. This can be used as a template to create your own.

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'athlete',
        filter: 'agTextColumnFilter',
        filterParams: {
            textMatcher: ({ filterOption, value, filterText }) => {
                if (filterText == null) {
                    return false;
                }
                switch (filterOption) {
                    case 'contains':
                        return value.indexOf(filterText) >= 0;
                    case 'notContains':
                        return value.indexOf(filterText) < 0;
                    case 'equals':
                        return value === filterText;
                    case 'notEqual':
                        return value != filterText;
                    case 'startsWith':
                        return value.indexOf(filterText) === 0;
                    case 'endsWith':
                        const index = value.lastIndexOf(filterText);
                        return index >= 0 && index === (value.length - filterText.length);
                    default:
                        // should never happen
                        console.warn('invalid filter type ' + filterOption);
                        return false;
                }
            }
        }
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

Note that the `textMatcher` is not called for the `blank` and `notBlank` options.

The example below demonstrates a `textMatcher` on the **Country** column:

- Most options are implemented as per the default grid implementation above.
- The `contains` option has additional logic so that aliases can be entered in the filter. E.g. if you filter using the text `'usa'` it will match `United States`, or `'holland'` will match `'Netherlands'`.

#### Text Custom Matcher

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule, TextFilterModule];

function contains(target: string, lookingFor: string) {
  return target && target.indexOf(lookingFor) >= 0;
}

const countryFilterParams: ITextFilterParams = {
  textMatcher: ({ filterOption, value, filterText }) => {
    if (filterText == null) {
      return false;
    }
    switch (filterOption) {
      case "contains":
        const aliases: Record<string, string> = {
          usa: "united states",
          holland: "netherlands",
        };
        const literalMatch = contains(value, filterText || "");
        return !!literalMatch || !!contains(value, aliases[filterText || ""]);
      case "notContains":
        return value.indexOf(filterText) < 0;
      case "equals":
        return value === filterText;
      case "notEqual":
        return value != filterText;
      case "startsWith":
        return value.indexOf(filterText) === 0;
      case "endsWith":
        const index = value.lastIndexOf(filterText);
        return index >= 0 && index === value.length - filterText.length;
      default:
        // should never happen
        console.warn("invalid filter type " + filterOption);
        return false;
    }
  },
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "country",
      filterParams: countryFilterParams,
    },
    {
      field: "athlete",
    },
    {
      field: "sport",
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      filter: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Text Custom Matcher](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-custom-matcher/reactFunctionalTs/)

## Text Filter Model

The Filter Model describes the current state of the applied Text Filter. If only one [Filter Condition](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-conditions/) is set, this will be a `TextFilterModel`:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `type` | `TextFilterOptionKey \| CustomFilterOptionKey \| null` |  |  |  |
| `filterType` | `'text'` |  |  |  |
| `filter` | `string \| null` |  |  |  |
| `filterTo` | `string \| null` |  |  |  |

If more than one Filter Condition is set, then multiple instances of the model are created and wrapped inside a Combined Model (`ICombinedSimpleModel<TextFilterModel>`). A Combined Model looks as follows:

```ts
// A filter combining multiple conditions
interface ICombinedSimpleModel<TextFilterModel> {
    filterType: string;

    operator: JoinOperator;

    // multiple instances of the Filter Model
    conditions: TextFilterModel[];
}

type JoinOperator = 'AND' | 'OR';
```

An example of a Filter Model with two conditions is as follows:

```js
// Text Filter with two conditions, both are equals type
const textEqualsSwimmingOrEqualsGymnastics = {
    filterType: 'text',
    operator: 'OR',
    conditions: [
        {
            filterType: 'text',
            type: 'equals',
            filter: 'Swimming'
        },
        {
            filterType: 'text',
            type: 'equals',
            filter: 'Gymnastics'
        }
    ]
};
```

## Text Filter Options

The Text Filter presents a list of [Filter Options](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-conditions/#filter-options) to the user.

The list of options is as follows:

| Option Name | Option Key | Included by Default |
| --- | --- | --- |
| Contains | `contains` | Yes |
| Does not contain | `notContains` | Yes |
| Equals | `equals` | Yes |
| Does not equal | `notEqual` | Yes |
| Begins with | `startsWith` | Yes |
| Ends with | `endsWith` | Yes |
| Blank | `blank` | Yes |
| Not blank | `notBlank` | Yes |
| Choose one | `empty` | No |

Note that the `empty` filter option is primarily used when creating [Custom Filter Options](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-conditions/#custom-filter-options). When 'Choose one' is displayed, the filter is not active.

The default option for the Text Filter is `contains`.

When providing filter options, the default filter option (or the first option if no default set) must be an option that displays an input or the `empty` filter option (as a filter option with no inputs would mean the filter is active by default).

The example below demonstrates configuring different filter options:

- For the **Athlete** column, there are only two filter options: `filterOptions = ['contains', 'notContains']`.
- For the **Country** column, there is only one filter option: `filterOptions = ['contains']`.
- For the **Sport** column, there is a different default filter option: `defaultOption = 'startsWith'`.

#### Text Filter Options

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule, TextFilterModule];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      filterParams: {
        filterOptions: ["contains", "notContains"],
        maxNumConditions: 1,
      } as ITextFilterParams,
    },
    {
      field: "country",
      filterParams: {
        filterOptions: ["contains"],
      } as ITextFilterParams,
    },
    {
      field: "sport",
      filterParams: {
        defaultOption: "startsWith",
      } as ITextFilterParams,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      filter: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Text Filter Options](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-filter-options/reactFunctionalTs/)

## Text Filter Values

By default, the values supplied to the Text Filter are retrieved from the data based on the `field` attribute. This can be overridden by providing a `filterValueGetter` in the Column Definition. This is similar to using a [Value Getter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-getters/), but is specific to the filter.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filterValueGetter` | `string \| ValueGetterFunc` |  |  |  |

## Applying the Text Filter

Applying the Text Filter is described in more detail in the following sections:

- [Apply, Clear, Reset and Cancel Buttons](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-applying/#apply-clear-reset-and-cancel-buttons)
- [Applying the UI Model](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-applying/#applying-the-ui-model)

## Data Updates

The Text Filter is not affected by data changes. When the grid data is updated, the filter value will remain unchanged and the filter will be re-applied based on the updated data (e.g. the displayed rows will update if necessary).


---
product: "AG Grid"
title: "Text Filter"
description: "Text Filters allow you to filter string data."
framework: angular
version: "36.2.0"
related:
    - title: "Number Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-number/"
    - title: "BigInt Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-bigint/"
    - title: "Date Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-date/"
    - title: "Set Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set/"
    - title: "Multi Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-multi/"
    - title: "Filter Conditions"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-conditions/"
    - title: "Applying Filters"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-applying/"
    - title: "Filter API"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Text Filter

Text Filters allow you to filter string data.

![Text Filter](https://www.ag-grid.com/archive/36.2.0/_astro/text-filter.m8-Z5BzG.png)

## Enabling Text Filters

#### Text Filter

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "athlete",
      filter: true,
    },
    {
      field: "country",
      filter: "agTextColumnFilter",
    },
    {
      field: "sport",
      filter: true,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Text Filter](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-filter/angular/)

The Text Filter is the default filter used in AG Grid Community, but it can also be explicitly configured as shown below:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'athlete',
        // Text Filter is used by default in Community version
        filter: true,
        filterParams: {
            // pass in additional parameters to the Text Filter
        },
    },
    {
        field: 'country',
        // explicitly configure column to use the Text Filter
        filter: 'agTextColumnFilter',
        filterParams: {
            // pass in additional parameters to the Text Filter
        },
    },
];
```

## Text Filter Parameters

Text Filters are configured though the `filterParams` attribute of the column definition (`ITextFilterParams` interface):

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `browserAutoComplete` | `boolean \| string` |  |  |  |
| `buttons` | `FilterAction[]` |  |  |  |
| `caseSensitive` | `boolean` |  |  |  |
| `closeOnApply` | `boolean` |  |  |  |
| `debounceMs` | `number` |  |  |  |
| `defaultJoinOperator` | `JoinOperator` |  |  |  |
| `defaultOption` | `TextFilterOptionKey \| CustomFilterOptionKey` |  |  |  |
| `filterOptions` | `(IFilterOptionDef \| TextFilterOptionKey \| AdvancedFilterOnlyOptionKey)[]` |  |  |  |
| `filterPlaceholder` | `FilterPlaceholderFunction \| string` |  |  |  |
| `maxNumConditions` | `number` |  |  |  |
| `numAlwaysVisibleConditions` | `number` |  |  |  |
| `readOnly` | `boolean` |  |  |  |
| `textFormatter` | `Function` |  |  |  |
| `textMatcher` | `TextMatcher` |  |  |  |
| `trimInput` | `boolean` |  |  |  |

The following example demonstrates configuring different Text Filter parameters:

- For the **Athlete** column:
  - The filter has a debounce of 200ms (`debounceMs = 200`).
  - Only one Filter Condition is allowed (`maxNumConditions = 1`)
- For the **Country** column:
  - The filter input will be trimmed when the filter is applied (`trimInput = true`)
  - There is a debounce of 1000ms (`debounceMs = 1000`)
- For the **Sport** column:
  - The filter is case-sensitive (`caseSensitive = true`)

#### Text Filter Parameters

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "athlete",
      filterParams: {
        debounceMs: 200,
        maxNumConditions: 1,
      } as ITextFilterParams,
    },
    {
      field: "country",
      filterParams: {
        trimInput: true,
        debounceMs: 1000,
      } as ITextFilterParams,
    },
    {
      field: "sport",
      filterParams: {
        caseSensitive: true,
      } as ITextFilterParams,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    filter: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Text Filter Parameters](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-filter-parameters/angular/)

Filter input fields share the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/input-fields/).

## Text Formatter

By default, the grid compares the Text Filter with the values in a case-insensitive way, by converting both the filter text and the values to lower case and comparing them; for example, `'o'` will match `'Olivia'` and `'Salmon'`. If you instead want to have case-sensitive matches, you can set `caseSensitive = true` in the `filterParams`, so that no lowercasing is performed. In this case, `'o'` would no longer match `'Olivia'`.

You might have more advanced requirements, for example to ignore accented characters. In this case, you can provide your own `textFormatter`, which is a function with the following signature:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `textFormatter` | `Function` |  |  |  |

`from` is the value coming from the grid. This can be from the `valueGetter` if there is any for the column, or the value as originally provided in the `rowData`. The function should return a string to be used for the purpose of filtering.

The Text Formatter is applied to both the filter text and the values before they are compared.

The following is an example function to remove accents and convert to lower case.

```js
const toLowerWithoutAccents = value => value == null
    ? null
    : value.toLowerCase()
        .replace(/[àáâãäå]/g, 'a')
        .replace(/æ/g, 'ae')
        .replace(/ç/g, 'c')
        .replace(/[èéêë]/g, 'e')
        .replace(/[ìíîï]/g, 'i')
        .replace(/ñ/g, 'n')
        .replace(/[òóôõö]/g, 'o')
        .replace(/œ/g, 'oe')
        .replace(/[ùúûü]/g, 'u')
        .replace(/[ýÿ]/g, 'y');
```

Note that when providing a Text Formatter, the `caseSensitive` parameter is ignored. In this situation, if you want to do a case-insensitive comparison, you will need to perform case conversion inside the `textFormatter` function.

The example below demonstrates a `textFormatter` on the **Athlete** column:

- If you search for `'o'` it will find `'ö'`. You can try this by searching the string `'Bjo'`.

#### Text Formatter

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "athlete",
      filterParams: athleteFilterParams,
    },
    {
      field: "country",
    },
    {
      field: "sport",
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    filter: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}

const athleteFilterParams: ITextFilterParams = {
  textFormatter: (r) => {
    if (r == null) return null;
    return r
      .toLowerCase()
      .replace(/[àáâãäå]/g, "a")
      .replace(/æ/g, "ae")
      .replace(/ç/g, "c")
      .replace(/[èéêë]/g, "e")
      .replace(/[ìíîï]/g, "i")
      .replace(/ñ/g, "n")
      .replace(/[òóôõö]/g, "o")
      .replace(/œ/g, "oe")
      .replace(/[ùúûü]/g, "u")
      .replace(/[ýÿ]/g, "y");
  },
};
```

[Live example: Text Formatter](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-formatter/angular/)

## Text Custom Matcher

In most cases, you can customise the Text Filter matching logic by providing your own [Text Formatter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-text/#text-formatter), e.g. to remove or replace characters in the filter text and values. The Text Formatter is applied to both the filter text and values before the filter comparison is performed.

For more advanced use cases, you can provide your own `textMatcher` to decide when to include a row in the filtered results. For example, you might want to apply different logic for the filter option `equals` than for `contains`.

The [Advanced Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-advanced/) compares text with the same `textFormatter`, `textMatcher` and `trimInput` the column is configured with, so a condition written there matches the rows this filter matches. `params.source` tells a `textFormatter` or `textMatcher` which of the two is asking.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `textMatcher` | `TextMatcher` |  |  |  |

The following is an example of a `textMatcher` that mimics the current implementation of AG Grid. This can be used as a template to create your own.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'athlete',
        filter: 'agTextColumnFilter',
        filterParams: {
            textMatcher: ({ filterOption, value, filterText }) => {
                if (filterText == null) {
                    return false;
                }
                switch (filterOption) {
                    case 'contains':
                        return value.indexOf(filterText) >= 0;
                    case 'notContains':
                        return value.indexOf(filterText) < 0;
                    case 'equals':
                        return value === filterText;
                    case 'notEqual':
                        return value != filterText;
                    case 'startsWith':
                        return value.indexOf(filterText) === 0;
                    case 'endsWith':
                        const index = value.lastIndexOf(filterText);
                        return index >= 0 && index === (value.length - filterText.length);
                    default:
                        // should never happen
                        console.warn('invalid filter type ' + filterOption);
                        return false;
                }
            }
        }
    }
];
```

Note that the `textMatcher` is not called for the `blank` and `notBlank` options.

The example below demonstrates a `textMatcher` on the **Country** column:

- Most options are implemented as per the default grid implementation above.
- The `contains` option has additional logic so that aliases can be entered in the filter. E.g. if you filter using the text `'usa'` it will match `United States`, or `'holland'` will match `'Netherlands'`.

#### Text Custom Matcher

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "country",
      filterParams: countryFilterParams,
    },
    {
      field: "athlete",
    },
    {
      field: "sport",
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    filter: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}

function contains(target: string, lookingFor: string) {
  return target && target.indexOf(lookingFor) >= 0;
}
const countryFilterParams: ITextFilterParams = {
  textMatcher: ({ filterOption, value, filterText }) => {
    if (filterText == null) {
      return false;
    }
    switch (filterOption) {
      case "contains":
        const aliases: Record<string, string> = {
          usa: "united states",
          holland: "netherlands",
        };
        const literalMatch = contains(value, filterText || "");
        return !!literalMatch || !!contains(value, aliases[filterText || ""]);
      case "notContains":
        return value.indexOf(filterText) < 0;
      case "equals":
        return value === filterText;
      case "notEqual":
        return value != filterText;
      case "startsWith":
        return value.indexOf(filterText) === 0;
      case "endsWith":
        const index = value.lastIndexOf(filterText);
        return index >= 0 && index === value.length - filterText.length;
      default:
        // should never happen
        console.warn("invalid filter type " + filterOption);
        return false;
    }
  },
};
```

[Live example: Text Custom Matcher](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-custom-matcher/angular/)

## Text Filter Model

The Filter Model describes the current state of the applied Text Filter. If only one [Filter Condition](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-conditions/) is set, this will be a `TextFilterModel`:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `type` | `TextFilterOptionKey \| CustomFilterOptionKey \| null` |  |  |  |
| `filterType` | `'text'` |  |  |  |
| `filter` | `string \| null` |  |  |  |
| `filterTo` | `string \| null` |  |  |  |

If more than one Filter Condition is set, then multiple instances of the model are created and wrapped inside a Combined Model (`ICombinedSimpleModel<TextFilterModel>`). A Combined Model looks as follows:

```ts
// A filter combining multiple conditions
interface ICombinedSimpleModel<TextFilterModel> {
    filterType: string;

    operator: JoinOperator;

    // multiple instances of the Filter Model
    conditions: TextFilterModel[];
}

type JoinOperator = 'AND' | 'OR';
```

An example of a Filter Model with two conditions is as follows:

```js
// Text Filter with two conditions, both are equals type
const textEqualsSwimmingOrEqualsGymnastics = {
    filterType: 'text',
    operator: 'OR',
    conditions: [
        {
            filterType: 'text',
            type: 'equals',
            filter: 'Swimming'
        },
        {
            filterType: 'text',
            type: 'equals',
            filter: 'Gymnastics'
        }
    ]
};
```

## Text Filter Options

The Text Filter presents a list of [Filter Options](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-conditions/#filter-options) to the user.

The list of options is as follows:

| Option Name | Option Key | Included by Default |
| --- | --- | --- |
| Contains | `contains` | Yes |
| Does not contain | `notContains` | Yes |
| Equals | `equals` | Yes |
| Does not equal | `notEqual` | Yes |
| Begins with | `startsWith` | Yes |
| Ends with | `endsWith` | Yes |
| Blank | `blank` | Yes |
| Not blank | `notBlank` | Yes |
| Choose one | `empty` | No |

Note that the `empty` filter option is primarily used when creating [Custom Filter Options](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-conditions/#custom-filter-options). When 'Choose one' is displayed, the filter is not active.

The default option for the Text Filter is `contains`.

When providing filter options, the default filter option (or the first option if no default set) must be an option that displays an input or the `empty` filter option (as a filter option with no inputs would mean the filter is active by default).

The example below demonstrates configuring different filter options:

- For the **Athlete** column, there are only two filter options: `filterOptions = ['contains', 'notContains']`.
- For the **Country** column, there is only one filter option: `filterOptions = ['contains']`.
- For the **Sport** column, there is a different default filter option: `defaultOption = 'startsWith'`.

#### Text Filter Options

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ITextFilterParams,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, TextFilterModule]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "athlete",
      filterParams: {
        filterOptions: ["contains", "notContains"],
        maxNumConditions: 1,
      } as ITextFilterParams,
    },
    {
      field: "country",
      filterParams: {
        filterOptions: ["contains"],
      } as ITextFilterParams,
    },
    {
      field: "sport",
      filterParams: {
        defaultOption: "startsWith",
      } as ITextFilterParams,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    filter: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Text Filter Options](https://www.ag-grid.com/archive/36.2.0/examples/filter-text/text-filter-options/angular/)

## Text Filter Values

By default, the values supplied to the Text Filter are retrieved from the data based on the `field` attribute. This can be overridden by providing a `filterValueGetter` in the Column Definition. This is similar to using a [Value Getter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-getters/), but is specific to the filter.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filterValueGetter` | `string \| ValueGetterFunc` |  |  |  |

## Applying the Text Filter

Applying the Text Filter is described in more detail in the following sections:

- [Apply, Clear, Reset and Cancel Buttons](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-applying/#apply-clear-reset-and-cancel-buttons)
- [Applying the UI Model](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-applying/#applying-the-ui-model)

## Data Updates

The Text Filter is not affected by data changes. When the grid data is updated, the filter value will remain unchanged and the filter will be re-applied based on the updated data (e.g. the displayed rows will update if necessary).
